using System;
using System.Diagnostics;
using System.IO;
using System.Windows.Forms;
using System.Xml;

namespace Monsterlaunch0r
{
    public partial class F0rm : Form
    {
        public static readonly string XML_FILE = "config.xml";
        public F0rm()
        {
            InitializeComponent();
        }

        private void Button1_Click(object sender, EventArgs e)
        {
            this.ShowOFD(this.programText1);
        }

        private void Button2_Click(object sender, EventArgs e)
        {
            this.ShowOFD(this.programText2);
        }

        private void ShowOFD(TextBox t)
        {
            using (OpenFileDialog ofn = new OpenFileDialog())
            {
                ofn.Filter = "Ausfhrbare Dateien (*.exe)|*.exe|Alle Dateien (*.*)|*.*";
                ofn.RestoreDirectory = true;
                if (ofn.ShowDialog(this) != DialogResult.OK) return;

                t.Text = ofn.FileName;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string[] names = new string[] { this.programText1.Text, this.programText2.Text };
            foreach (string s in names)
            {
                if (!File.Exists(s))
                {
                    MessageBox.Show("Datei nicht vorhanden!");
                    return;
                }
            }

            foreach (string s in names)
            {
                using (Process p = new Process())
                {
                    p.StartInfo.FileName = s;
                    p.Start();
                }
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            if (!File.Exists(XML_FILE))
                return;
            using (XmlReader reader = XmlReader.Create(XML_FILE))
            {
                reader.ReadStartElement("programs");
                
                this.programText1.Text = reader.GetAttribute("path");

                reader.Read();
                this.programText2.Text = reader.GetAttribute("path");
                
                reader.Close();
            }
        }

        protected override void OnClosing(System.ComponentModel.CancelEventArgs e)
        {
            using (XmlWriter writer = XmlWriter.Create(XML_FILE))
            {
                writer.WriteStartElement("programs");
                
                writer.WriteStartElement("p1");
                writer.WriteAttributeString("path", programText1.Text);
                writer.WriteEndElement();

                writer.WriteStartElement("p2");
                writer.WriteAttributeString("path", programText2.Text);
                writer.WriteEndElement();

                writer.WriteEndElement();

                writer.Flush();
                writer.Close();
            }
        }
    }
}